# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.typed_array__id_e import TypedArray_IdE


class DenseArray_IdE(TypedArray_IdE):
    """
    DenseArray - Contiguous storage for N-way arrays.
    
    Superclass: TypedArray[float64]
    
    DenseArray is a concrete Array implementation that stores
    values using a contiguous block of memory.  Values are stored with
    fortran ordering, meaning that if you iterated over the memory block,
    the left-most coordinates would vary the fastest.
    
    In addition to the retrieval and update methods provided by
    TypedArray, DenseArray provides methods to:
    
    Fill the entire array with a specific value.
    
    Retrieve a pointer to the storage memory block.
    
    See Also:
    
    Array, TypedArray, SparseArray
    
    Thanks:
    
    Developed by Timothy M. Shead (tshead@sandia.gov) at Sandia National
    Laboratories.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkDenseArray_IdE, obj, update, **traits)
    
    def get_value_n(self, *args):
        """
        V.get_value_n(int) -> float
        C++: const double &GetValueN(const SizeT n)"""
        ret = self._wrap_call(self._vtk_obj.GetValueN, *args)
        return ret

    def set_value_n(self, *args):
        """
        V.set_value_n(int, float)
        C++: void SetValueN(const SizeT n, const double &value)"""
        ret = self._wrap_call(self._vtk_obj.SetValueN, *args)
        return ret

    def get_value(self, *args):
        """
        V.get_value(int) -> float
        C++: const double &GetValue(CoordinateT i)
        V.get_value(int, int) -> float
        C++: const double &GetValue(CoordinateT i, CoordinateT j)
        V.get_value(int, int, int) -> float
        C++: const double &GetValue(CoordinateT i, CoordinateT j,
            CoordinateT k)
        V.get_value(ArrayCoordinates) -> float
        C++: const double &GetValue(
            const ArrayCoordinates &coordinates)"""
        my_args = deref_array(args, [['int'], ('int', 'int'), ('int', 'int', 'int'), ['vtkArrayCoordinates']])
        ret = self._wrap_call(self._vtk_obj.GetValue, *my_args)
        return ret

    def set_value(self, *args):
        """
        V.set_value(int, float)
        C++: void SetValue(CoordinateT i, const double &value)
        V.set_value(int, int, float)
        C++: void SetValue(CoordinateT i, CoordinateT j,
            const double &value)
        V.set_value(int, int, int, float)
        C++: void SetValue(CoordinateT i, CoordinateT j, CoordinateT k,
            const double &value)
        V.set_value(ArrayCoordinates, float)
        C++: void SetValue(const ArrayCoordinates &coordinates,
            const double &value)"""
        my_args = deref_array(args, [('int', 'float'), ('int', 'int', 'float'), ('int', 'int', 'int', 'float'), ('vtkArrayCoordinates', 'float')])
        ret = self._wrap_call(self._vtk_obj.SetValue, *my_args)
        return ret

    def _get_storage(self):
        return self._vtk_obj.GetStorage()
    storage = traits.Property(_get_storage, help=\
        """
        Returns a mutable reference to the underlying storage.  Values
        are stored contiguously with fortran ordering.  Use at your own
        risk!
        """
    )

    def fill(self, *args):
        """
        V.fill(float)
        C++: void Fill(const double &value)
        Fills every element in the array with the given value.
        """
        ret = self._wrap_call(self._vtk_obj.Fill, *args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('reference_count', 'GetReferenceCount'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('name',
    'GetName'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(DenseArray_IdE, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit DenseArray_IdE properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['name']),
            title='Edit DenseArray_IdE properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit DenseArray_IdE properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

