# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.threaded_image_algorithm import ThreadedImageAlgorithm


class ImageGradientMagnitude(ThreadedImageAlgorithm):
    """
    ImageGradientMagnitude - Computes magnitude of the gradient.
    
    Superclass: ThreadedImageAlgorithm
    
    ImageGradientMagnitude computes the gradient magnitude of an
    image. Setting the dimensionality determines whether the gradient is
    computed on 2d images, or 3d volumes.  The default is two dimensional
    XY images.
    
    See Also:
    
    ImageGradient ImageMagnitude
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkImageGradientMagnitude, obj, update, **traits)
    
    handle_boundaries = tvtk_base.true_bool_trait(help=\
        """
        If "_handle_boundaries_on" then boundary pixels are duplicated So
        central differences can get values.
        """
    )

    def _handle_boundaries_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetHandleBoundaries,
                        self.handle_boundaries_)

    dimensionality = traits.Trait(2, traits.Range(2, 3, enter_set=True, auto_set=False), help=\
        """
        Determines how the input is interpreted (set of 2d slices ...)
        """
    )

    def _dimensionality_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDimensionality,
                        self.dimensionality)

    _updateable_traits_ = \
    (('dimensionality', 'GetDimensionality'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('number_of_threads',
    'GetNumberOfThreads'), ('progress_text', 'GetProgressText'),
    ('reference_count', 'GetReferenceCount'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('progress', 'GetProgress'),
    ('handle_boundaries', 'GetHandleBoundaries'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'handle_boundaries', 'release_data_flag', 'dimensionality',
    'number_of_threads', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ImageGradientMagnitude, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ImageGradientMagnitude properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['handle_boundaries'], [], ['dimensionality',
            'number_of_threads']),
            title='Edit ImageGradientMagnitude properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ImageGradientMagnitude properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

