# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.image_reslice import ImageReslice


class ImagePermute(ImageReslice):
    """
    ImagePermute -  Permutes axes of input.
    
    Superclass: ImageReslice
    
    ImagePermute reorders the axes of the input. Filtered axes specify
    the input axes which become X, Y, Z.  The input has to have the same
    scalar type of the output. The filter does copy the data when it
    executes. This filter is actually a very thin wrapper around
    ImageReslice.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkImagePermute, obj, update, **traits)
    
    filtered_axes = traits.Array(auto_set=False, enter_set=True, shape=(3,), dtype=int, value=(0, 1, 2), cols=3, help=\
        """
        The filtered axes are the input axes that get relabeled to X,Y,Z.
        """
    )

    def _filtered_axes_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFilteredAxes,
                        self.filtered_axes)

    _updateable_traits_ = \
    (('auto_crop_output', 'GetAutoCropOutput'), ('mirror', 'GetMirror'),
    ('slab_slice_spacing_fraction', 'GetSlabSliceSpacingFraction'),
    ('generate_stencil_output', 'GetGenerateStencilOutput'), ('wrap',
    'GetWrap'), ('border', 'GetBorder'), ('background_color',
    'GetBackgroundColor'), ('output_scalar_type', 'GetOutputScalarType'),
    ('progress_text', 'GetProgressText'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('progress', 'GetProgress'), ('interpolation_mode',
    'GetInterpolationMode'), ('interpolate', 'GetInterpolate'),
    ('slab_mode', 'GetSlabMode'), ('reference_count',
    'GetReferenceCount'), ('background_level', 'GetBackgroundLevel'),
    ('reslice_axes_origin', 'GetResliceAxesOrigin'),
    ('output_dimensionality', 'GetOutputDimensionality'), ('scalar_shift',
    'GetScalarShift'), ('transform_input_sampling',
    'GetTransformInputSampling'), ('slab_trapezoid_integration',
    'GetSlabTrapezoidIntegration'), ('output_extent', 'GetOutputExtent'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('output_spacing', 'GetOutputSpacing'), ('output_origin',
    'GetOutputOrigin'), ('optimization', 'GetOptimization'),
    ('reslice_axes_direction_cosines', 'GetResliceAxesDirectionCosines'),
    ('filtered_axes', 'GetFilteredAxes'), ('number_of_threads',
    'GetNumberOfThreads'), ('debug', 'GetDebug'), ('scalar_scale',
    'GetScalarScale'), ('slab_number_of_slices', 'GetSlabNumberOfSlices'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'auto_crop_output', 'border', 'debug',
    'generate_stencil_output', 'global_warning_display', 'interpolate',
    'mirror', 'optimization', 'release_data_flag',
    'slab_trapezoid_integration', 'transform_input_sampling', 'wrap',
    'interpolation_mode', 'slab_mode', 'background_color',
    'background_level', 'filtered_axes', 'number_of_threads',
    'output_dimensionality', 'output_extent', 'output_origin',
    'output_scalar_type', 'output_spacing', 'progress_text',
    'reslice_axes_direction_cosines', 'reslice_axes_origin',
    'scalar_scale', 'scalar_shift', 'slab_number_of_slices',
    'slab_slice_spacing_fraction'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ImagePermute, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ImagePermute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['auto_crop_output', 'border', 'generate_stencil_output',
            'interpolate', 'mirror', 'optimization', 'slab_trapezoid_integration',
            'transform_input_sampling', 'wrap'], ['interpolation_mode',
            'slab_mode'], ['background_color', 'background_level',
            'filtered_axes', 'number_of_threads', 'output_dimensionality',
            'output_extent', 'output_origin', 'output_scalar_type',
            'output_spacing', 'reslice_axes_direction_cosines',
            'reslice_axes_origin', 'scalar_scale', 'scalar_shift',
            'slab_number_of_slices', 'slab_slice_spacing_fraction']),
            title='Edit ImagePermute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ImagePermute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

