# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.threaded_image_algorithm import ThreadedImageAlgorithm


class ImageShrink3D(ThreadedImageAlgorithm):
    """
    ImageShrink3D - Subsamples an image.
    
    Superclass: ThreadedImageAlgorithm
    
    ImageShrink3D shrinks an image by sub sampling on a uniform grid
    (integer multiples).
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkImageShrink3D, obj, update, **traits)
    
    averaging = tvtk_base.true_bool_trait(help=\
        """
        Choose Mean, Minimum, Maximum, Median or sub sampling. The
        neighborhood operations are not centered on the sampled pixel.
        This may cause a half pixel shift in your output image. You can
        changed "Shift" to get around this. ImageGaussianSmooth or
        ImageMean with strides.
        """
    )

    def _averaging_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAveraging,
                        self.averaging_)

    minimum = tvtk_base.false_bool_trait(help=\
        """
        
        """
    )

    def _minimum_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMinimum,
                        self.minimum_)

    median = tvtk_base.false_bool_trait(help=\
        """
        
        """
    )

    def _median_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMedian,
                        self.median_)

    maximum = tvtk_base.false_bool_trait(help=\
        """
        
        """
    )

    def _maximum_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMaximum,
                        self.maximum_)

    mean = tvtk_base.true_bool_trait(help=\
        """
        
        """
    )

    def _mean_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMean,
                        self.mean_)

    shift = traits.Array(auto_set=False, enter_set=True, shape=(3,), dtype=int, value=(0, 0, 0), cols=3, help=\
        """
        
        """
    )

    def _shift_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetShift,
                        self.shift)

    shrink_factors = traits.Array(auto_set=False, enter_set=True, shape=(3,), dtype=int, value=(1, 1, 1), cols=3, help=\
        """
        
        """
    )

    def _shrink_factors_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetShrinkFactors,
                        self.shrink_factors)

    _updateable_traits_ = \
    (('reference_count', 'GetReferenceCount'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('progress_text', 'GetProgressText'),
    ('averaging', 'GetAveraging'), ('median', 'GetMedian'), ('maximum',
    'GetMaximum'), ('shrink_factors', 'GetShrinkFactors'),
    ('number_of_threads', 'GetNumberOfThreads'), ('minimum',
    'GetMinimum'), ('release_data_flag', 'GetReleaseDataFlag'), ('shift',
    'GetShift'), ('debug', 'GetDebug'), ('progress', 'GetProgress'),
    ('abort_execute', 'GetAbortExecute'), ('mean', 'GetMean'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'averaging', 'debug', 'global_warning_display',
    'maximum', 'mean', 'median', 'minimum', 'release_data_flag',
    'number_of_threads', 'progress_text', 'shift', 'shrink_factors'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ImageShrink3D, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ImageShrink3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['averaging', 'maximum', 'mean', 'median', 'minimum'], [],
            ['number_of_threads', 'shift', 'shrink_factors']),
            title='Edit ImageShrink3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ImageShrink3D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

