# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.sphere_source import SphereSource


class PSphereSource(SphereSource):
    """
    PSphereSource - sphere source that supports pieces
    
    Superclass: SphereSource
    
    
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkPSphereSource, obj, update, **traits)
    
    def _get_estimated_memory_size(self):
        return self._vtk_obj.GetEstimatedMemorySize()
    estimated_memory_size = traits.Property(_get_estimated_memory_size, help=\
        """
        Get the estimated memory size in kibibytes (1024 bytes).
        """
    )

    _updateable_traits_ = \
    (('lat_long_tessellation', 'GetLatLongTessellation'),
    ('reference_count', 'GetReferenceCount'), ('end_theta',
    'GetEndTheta'), ('theta_resolution', 'GetThetaResolution'),
    ('phi_resolution', 'GetPhiResolution'), ('progress', 'GetProgress'),
    ('output_points_precision', 'GetOutputPointsPrecision'), ('center',
    'GetCenter'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('end_phi', 'GetEndPhi'), ('start_phi', 'GetStartPhi'),
    ('progress_text', 'GetProgressText'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('radius', 'GetRadius'), ('start_theta',
    'GetStartTheta'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'lat_long_tessellation', 'release_data_flag', 'center', 'end_phi',
    'end_theta', 'output_points_precision', 'phi_resolution',
    'progress_text', 'radius', 'start_phi', 'start_theta',
    'theta_resolution'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(PSphereSource, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit PSphereSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['lat_long_tessellation'], [], ['center', 'end_phi',
            'end_theta', 'output_points_precision', 'phi_resolution', 'radius',
            'start_phi', 'start_theta', 'theta_resolution']),
            title='Edit PSphereSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit PSphereSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

