# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.data_set_writer import DataSetWriter


class SimplePointsWriter(DataSetWriter):
    """
    SimplePointsWriter - write a file of xyz coordinates
    
    Superclass: DataSetWriter
    
    SimplePointsWriter writes a simple file of xyz coordinates
    
    See Also:
    
    SimplePointsReader
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkSimplePointsWriter, obj, update, **traits)
    
    decimal_precision = traits.Int(6, auto_set=False, enter_set=True, help=\
        """
        
        """
    )

    def _decimal_precision_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDecimalPrecision,
                        self.decimal_precision)

    _updateable_traits_ = \
    (('vectors_name', 'GetVectorsName'), ('tensors_name',
    'GetTensorsName'), ('file_type', 'GetFileType'), ('file_name',
    'GetFileName'), ('scalars_name', 'GetScalarsName'),
    ('write_to_output_string', 'GetWriteToOutputString'), ('normals_name',
    'GetNormalsName'), ('t_coords_name', 'GetTCoordsName'),
    ('field_data_name', 'GetFieldDataName'), ('decimal_precision',
    'GetDecimalPrecision'), ('global_ids_name', 'GetGlobalIdsName'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('lookup_table_name', 'GetLookupTableName'), ('header', 'GetHeader'),
    ('reference_count', 'GetReferenceCount'), ('edge_flags_name',
    'GetEdgeFlagsName'), ('pedigree_ids_name', 'GetPedigreeIdsName'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'), ('progress',
    'GetProgress'), ('progress_text', 'GetProgressText'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'write_to_output_string', 'file_type',
    'decimal_precision', 'edge_flags_name', 'field_data_name',
    'file_name', 'global_ids_name', 'header', 'lookup_table_name',
    'normals_name', 'pedigree_ids_name', 'progress_text', 'scalars_name',
    't_coords_name', 'tensors_name', 'vectors_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(SimplePointsWriter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit SimplePointsWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['write_to_output_string'], ['file_type'], ['decimal_precision',
            'edge_flags_name', 'field_data_name', 'file_name', 'global_ids_name',
            'header', 'lookup_table_name', 'normals_name', 'pedigree_ids_name',
            'scalars_name', 't_coords_name', 'tensors_name', 'vectors_name']),
            title='Edit SimplePointsWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit SimplePointsWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

