# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.xml_writer import XMLWriter


class XMLStructuredDataWriter(XMLWriter):
    """
    XMLStructuredDataWriter - Superclass for VTK XML structured data
    writers.
    
    Superclass: XMLWriter
    
    XMLStructuredDataWriter provides VTK XML writing functionality
    that is common among all the structured data formats.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkXMLStructuredDataWriter, obj, update, **traits)
    
    write_piece = traits.Int(-1, auto_set=False, enter_set=True, help=\
        """
        Get/Set the piece to write to the file.  If this is negative, all
        pieces will be written.
        """
    )

    def _write_piece_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWritePiece,
                        self.write_piece)

    number_of_pieces = traits.Int(1, auto_set=False, enter_set=True, help=\
        """
        Get/Set the number of pieces used to stream the image through the
        pipeline while writing to the file.
        """
    )

    def _number_of_pieces_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfPieces,
                        self.number_of_pieces)

    write_extent = traits.Array(auto_set=False, enter_set=True, shape=(6,), dtype=int, value=(0, -1, 0, -1, 0, -1), cols=3, help=\
        """
        
        """
    )

    def _write_extent_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWriteExtent,
                        self.write_extent)

    ghost_level = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Get/Set the ghost level used to pad each piece.
        """
    )

    def _ghost_level_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGhostLevel,
                        self.ghost_level)

    _updateable_traits_ = \
    (('byte_order', 'GetByteOrder'), ('file_name', 'GetFileName'),
    ('data_mode', 'GetDataMode'), ('write_to_output_string',
    'GetWriteToOutputString'), ('id_type', 'GetIdType'), ('ghost_level',
    'GetGhostLevel'), ('time_step', 'GetTimeStep'), ('block_size',
    'GetBlockSize'), ('write_extent', 'GetWriteExtent'),
    ('number_of_time_steps', 'GetNumberOfTimeSteps'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('time_step_range', 'GetTimeStepRange'), ('reference_count',
    'GetReferenceCount'), ('progress_text', 'GetProgressText'),
    ('header_type', 'GetHeaderType'), ('abort_execute',
    'GetAbortExecute'), ('encode_appended_data', 'GetEncodeAppendedData'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('progress', 'GetProgress'), ('number_of_pieces',
    'GetNumberOfPieces'), ('write_piece', 'GetWritePiece'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'encode_appended_data',
    'global_warning_display', 'release_data_flag',
    'write_to_output_string', 'byte_order', 'data_mode', 'header_type',
    'id_type', 'block_size', 'file_name', 'ghost_level',
    'number_of_pieces', 'number_of_time_steps', 'progress_text',
    'time_step', 'time_step_range', 'write_extent', 'write_piece'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(XMLStructuredDataWriter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit XMLStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['encode_appended_data', 'write_to_output_string'],
            ['byte_order', 'data_mode', 'header_type', 'id_type'], ['block_size',
            'file_name', 'ghost_level', 'number_of_pieces',
            'number_of_time_steps', 'time_step', 'time_step_range',
            'write_extent', 'write_piece']),
            title='Edit XMLStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit XMLStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

