# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.xml_writer import XMLWriter


class XMLPDataWriter(XMLWriter):
    """
    XMLPDataWriter - Write data in a parallel XML format.
    
    Superclass: XMLWriter
    
    XMLPDataWriter is the superclass for all XML parallel data set
    writers.  It provides functionality needed for writing parallel
    formats, such as the selection of which writer writes the summary
    file and what range of pieces are assigned to each serial writer.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkXMLPDataWriter, obj, update, **traits)
    
    write_summary_file = tvtk_base.true_bool_trait(help=\
        """
        Get/Set whether the writer should write the summary file that
        refers to all of the pieces' individual files. This is on by
        default. Note that only the first process writes the summary
        file.
        """
    )

    def _write_summary_file_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWriteSummaryFile,
                        self.write_summary_file_)

    start_piece = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Get/Set the range of pieces assigned to this writer.
        """
    )

    def _start_piece_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetStartPiece,
                        self.start_piece)

    def _get_controller(self):
        return wrap_vtk(self._vtk_obj.GetController())
    def _set_controller(self, arg):
        old_val = self._get_controller()
        self._wrap_call(self._vtk_obj.SetController,
                        deref_vtk(arg))
        self.trait_property_changed('controller', old_val, arg)
    controller = traits.Property(_get_controller, _set_controller, help=\
        """
        Controller used to communicate data type of blocks. By default,
        the global controller is used. If you want another controller to
        be used, set it with this.
        """
    )

    ghost_level = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Get/Set the ghost level used for this writer's piece.
        """
    )

    def _ghost_level_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGhostLevel,
                        self.ghost_level)

    number_of_pieces = traits.Int(1, auto_set=False, enter_set=True, help=\
        """
        Get/Set the number of pieces that are being written in parallel.
        """
    )

    def _number_of_pieces_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfPieces,
                        self.number_of_pieces)

    end_piece = traits.Int(0, auto_set=False, enter_set=True, help=\
        """
        Get/Set the range of pieces assigned to this writer.
        """
    )

    def _end_piece_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetEndPiece,
                        self.end_piece)

    _updateable_traits_ = \
    (('ghost_level', 'GetGhostLevel'), ('byte_order', 'GetByteOrder'),
    ('file_name', 'GetFileName'), ('data_mode', 'GetDataMode'),
    ('write_to_output_string', 'GetWriteToOutputString'), ('id_type',
    'GetIdType'), ('end_piece', 'GetEndPiece'), ('time_step',
    'GetTimeStep'), ('block_size', 'GetBlockSize'),
    ('number_of_time_steps', 'GetNumberOfTimeSteps'),
    ('write_summary_file', 'GetWriteSummaryFile'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('time_step_range', 'GetTimeStepRange'), ('reference_count',
    'GetReferenceCount'), ('progress_text', 'GetProgressText'),
    ('start_piece', 'GetStartPiece'), ('header_type', 'GetHeaderType'),
    ('abort_execute', 'GetAbortExecute'), ('encode_appended_data',
    'GetEncodeAppendedData'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('progress', 'GetProgress'),
    ('number_of_pieces', 'GetNumberOfPieces'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'encode_appended_data',
    'global_warning_display', 'release_data_flag', 'write_summary_file',
    'write_to_output_string', 'byte_order', 'data_mode', 'header_type',
    'id_type', 'block_size', 'end_piece', 'file_name', 'ghost_level',
    'number_of_pieces', 'number_of_time_steps', 'progress_text',
    'start_piece', 'time_step', 'time_step_range'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(XMLPDataWriter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit XMLPDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['encode_appended_data', 'write_summary_file',
            'write_to_output_string'], ['byte_order', 'data_mode', 'header_type',
            'id_type'], ['block_size', 'end_piece', 'file_name', 'ghost_level',
            'number_of_pieces', 'number_of_time_steps', 'start_piece',
            'time_step', 'time_step_range']),
            title='Edit XMLPDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit XMLPDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

