# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.xmlp_data_writer import XMLPDataWriter


class XMLPStructuredDataWriter(XMLPDataWriter):
    """
    XMLPStructuredDataWriter - Superclass for PVTK XML structured data
    writers.
    
    Superclass: XMLPDataWriter
    
    XMLPStructuredDataWriter provides PVTK XML writing functionality
    that is common among all the parallel structured data formats.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkXMLPStructuredDataWriter, obj, update, **traits)
    
    _updateable_traits_ = \
    (('byte_order', 'GetByteOrder'), ('file_name', 'GetFileName'),
    ('time_step', 'GetTimeStep'), ('data_mode', 'GetDataMode'),
    ('write_to_output_string', 'GetWriteToOutputString'), ('id_type',
    'GetIdType'), ('end_piece', 'GetEndPiece'), ('ghost_level',
    'GetGhostLevel'), ('block_size', 'GetBlockSize'),
    ('number_of_time_steps', 'GetNumberOfTimeSteps'),
    ('write_summary_file', 'GetWriteSummaryFile'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('time_step_range', 'GetTimeStepRange'), ('reference_count',
    'GetReferenceCount'), ('progress_text', 'GetProgressText'),
    ('start_piece', 'GetStartPiece'), ('header_type', 'GetHeaderType'),
    ('abort_execute', 'GetAbortExecute'), ('encode_appended_data',
    'GetEncodeAppendedData'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('progress', 'GetProgress'),
    ('number_of_pieces', 'GetNumberOfPieces'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'encode_appended_data',
    'global_warning_display', 'release_data_flag', 'write_summary_file',
    'write_to_output_string', 'byte_order', 'data_mode', 'header_type',
    'id_type', 'block_size', 'end_piece', 'file_name', 'ghost_level',
    'number_of_pieces', 'number_of_time_steps', 'progress_text',
    'start_piece', 'time_step', 'time_step_range'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(XMLPStructuredDataWriter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit XMLPStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['encode_appended_data', 'write_summary_file',
            'write_to_output_string'], ['byte_order', 'data_mode', 'header_type',
            'id_type'], ['block_size', 'end_piece', 'file_name', 'ghost_level',
            'number_of_pieces', 'number_of_time_steps', 'start_piece',
            'time_step', 'time_step_range']),
            title='Edit XMLPStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit XMLPStructuredDataWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

