# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.xml_uniform_grid_amr_writer import XMLUniformGridAMRWriter


class XMLPUniformGridAMRWriter(XMLUniformGridAMRWriter):
    """
    XMLPUniformGridAMRWriter - parallel writer for
    
    Superclass: XMLUniformGridAMRWriter
    
    XMLPCompositeDataWriter writes (in parallel or serially)
    UniformGridAMR and subclasses. When running in parallel all
    processes are expected to have the same meta-data (i.e. amr-boxes,
    structure, etc.) however they may now have the missing data-blocks.
    This class extends XMLUniformGridAMRWriter to communicate
    information about data blocks to the root node so that the root node
    can write the XML file describing the structure correctly.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkXMLPUniformGridAMRWriter, obj, update, **traits)
    
    def _get_controller(self):
        return wrap_vtk(self._vtk_obj.GetController())
    def _set_controller(self, arg):
        old_val = self._get_controller()
        self._wrap_call(self._vtk_obj.SetController,
                        deref_vtk(arg))
        self.trait_property_changed('controller', old_val, arg)
    controller = traits.Property(_get_controller, _set_controller, help=\
        """
        Controller used to communicate data type of blocks. By default,
        the global controller is used. If you want another controller to
        be used, set it with this. If no controller is set, only the
        local blocks will be written to the meta-file.
        """
    )

    _updateable_traits_ = \
    (('byte_order', 'GetByteOrder'), ('file_name', 'GetFileName'),
    ('data_mode', 'GetDataMode'), ('write_to_output_string',
    'GetWriteToOutputString'), ('id_type', 'GetIdType'), ('ghost_level',
    'GetGhostLevel'), ('time_step', 'GetTimeStep'), ('block_size',
    'GetBlockSize'), ('number_of_time_steps', 'GetNumberOfTimeSteps'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('time_step_range', 'GetTimeStepRange'), ('reference_count',
    'GetReferenceCount'), ('progress_text', 'GetProgressText'),
    ('header_type', 'GetHeaderType'), ('abort_execute',
    'GetAbortExecute'), ('encode_appended_data', 'GetEncodeAppendedData'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('write_meta_file',
    'GetWriteMetaFile'), ('debug', 'GetDebug'), ('progress',
    'GetProgress'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'encode_appended_data',
    'global_warning_display', 'release_data_flag',
    'write_to_output_string', 'byte_order', 'data_mode', 'header_type',
    'id_type', 'block_size', 'file_name', 'ghost_level',
    'number_of_time_steps', 'progress_text', 'time_step',
    'time_step_range', 'write_meta_file'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(XMLPUniformGridAMRWriter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit XMLPUniformGridAMRWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['encode_appended_data', 'write_to_output_string'],
            ['byte_order', 'data_mode', 'header_type', 'id_type'], ['block_size',
            'file_name', 'ghost_level', 'number_of_time_steps', 'time_step',
            'time_step_range', 'write_meta_file']),
            title='Edit XMLPUniformGridAMRWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit XMLPUniformGridAMRWriter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

